using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using Exferia_Formularios;
using Exferia_General;
using Exferia_GestionDocumental._1_Datos;
using Exferia_GestionDocumental.General;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Transactions;
using System.Windows.Forms;

namespace Exferia_GestionDocumental._3_Vistas.Controladoras
{
    public class P_ConexionBD_Externa_Controladora
    {
        #region Variables Generales
        private P_ConexionBD_Externa g_frm_P_ConexionBD_Externa = null;//Variable que enlaza con la pantalla asociada
        private PE_Esperando g_frm_PE_Esperando;//Pantalla de Espera, para cuando se ejecutan tareas pesadas como cargar, guardar, etc

        //Clases de Negocio Necesarias para la carga de datos
        private GTD_ConexionBDExterna_Datos g_obj_GTD_ConexionBDExterna_Datos = new GTD_ConexionBDExterna_Datos();
        private ConexionExterna_Datos g_obj_ConexionExterna_Datos = new ConexionExterna_Datos();
        private Encriptador g_obj_Encriptador = new Encriptador();

        //Modelos necesarios
        public GTD_ConexionBDExterna g_mdl_GTD_ConexionBDExterna = null;

        public bool g_bol_Termino_CargaDatos_Inicial = false;//Se utiliza para saber cuando se termina la carga de datos estaticos inciales

        //Tareea Asincrona de carga de datos
        private BackgroundWorker g_obj_TareaAsincrona_CargarDatos;

        //Tareea Asincrona de grabar de datos
        private BackgroundWorker g_obj_TareaAsincrona_GrabarDatos;
        private bool g_bol_GrabarDatos_TerminoCorrectamente = true;

        //Tareea Asincrona de Borrar de datos
        private BackgroundWorker g_obj_TareaAsincrona_BorrarDatos;

        private List<INTERNO_ComboBox_Modelo> g_lst_INTERNO_ComboBox_Modelo_TIPOBASEDATOS = null;

        public bool g_bol_CampoCodigo_Numerico = false;

        #endregion

        public P_ConexionBD_Externa_Controladora(P_ConexionBD_Externa _frm_P_ConexionBD_Externa)
        {
            g_frm_P_ConexionBD_Externa = _frm_P_ConexionBD_Externa;

            //cargar todos los valores de los combos estaticos
            Cargar_DatosIniciales();
        }

        #region Datos Iniciales
        public void Cargar_DatosIniciales()
        {
            //Exferia_ComboBox_Tipos
            g_lst_INTERNO_ComboBox_Modelo_TIPOBASEDATOS = ListadosEstaticos.Devolver_Tipos_BaseDatos();
            if (g_lst_INTERNO_ComboBox_Modelo_TIPOBASEDATOS != null)
            {
                g_frm_P_ConexionBD_Externa.Exferia_ComboBox_Tipo.Items.Clear();
                g_frm_P_ConexionBD_Externa.Exferia_ComboBox_Tipo.DataSource = g_lst_INTERNO_ComboBox_Modelo_TIPOBASEDATOS;
                g_frm_P_ConexionBD_Externa.Exferia_ComboBox_Tipo.SelectedIndex = 0;
            }
        }
        #endregion

        #region Vaciar Datos
        public void VaciarDatos()
        {
            //Modelo
            g_mdl_GTD_ConexionBDExterna = null;

            //codigo
            g_frm_P_ConexionBD_Externa.Exferia_TextBox_Codigo.Text = "";

            //descripcion
            g_frm_P_ConexionBD_Externa.Exferia_TextBox_Descripcion.Text = "";

            //servidor
            g_frm_P_ConexionBD_Externa.Exferia_TextBox_Servidor.Text = "";

            //basedatos
            g_frm_P_ConexionBD_Externa.Exferia_TextBox_BaseDeDatos.Text = "";

            //tipobasedatos
            g_frm_P_ConexionBD_Externa.Exferia_ComboBox_Tipo.SelectedIndex = 0;

            //SinClave
            g_frm_P_ConexionBD_Externa.Exferia_RadioButton_SinClave.Checked = true;

            //ConClave
            g_frm_P_ConexionBD_Externa.Exferia_RadioButton_ConClave.Checked = false;
           
            //usuario
            g_frm_P_ConexionBD_Externa.Exferia_TextBox_Usuario.Text = "";

            //clave
            g_frm_P_ConexionBD_Externa.Exferia_TextBox_Clave.Text = "";

            string[] str_Separador = new string[] { " [" };
            //Si ya hay valores de objeto, los elimino para rellenarlos de nuevo
            if (g_frm_P_ConexionBD_Externa.P_Base_TituloPantalla.Split(str_Separador, StringSplitOptions.None).Count() > 1)
            {
                g_frm_P_ConexionBD_Externa.P_Base_TituloPantalla = (g_frm_P_ConexionBD_Externa.P_Base_TituloPantalla.Split(str_Separador, StringSplitOptions.None))[0];
            }

            //Actualizar el Boton de Seleccion de pantalla ####################################################
            Variables.G_EMS_CONTROL_MENUSUPERIOR.Update_Texto_NombrePantalla(g_frm_P_ConexionBD_Externa.Tag.ToString());
            //#################################################################################################
        }
        #endregion

        #region Comprobacion de cambios, para  grabar o no antes de salir o cambiar de registro
        public bool ComprobarCambios()
        {
            if (g_frm_P_ConexionBD_Externa.P_Base_SeModificoDatosPantalla)
            {
                if (Mensajes.MostrarMensaje_Pregunta(Mensajes.G_STR_MENSAJES_GENERAL_PREGUNTA_GUARDARCAMBIOS()))
                {
                    GrabarDatos();

                    //Te quedas espernado a que termine la tarea asincrona de grabar
                    while (g_obj_TareaAsincrona_GrabarDatos.IsBusy)
                        Application.DoEvents();

                    return g_bol_GrabarDatos_TerminoCorrectamente;
                }
            }
            return true;
        }
        #endregion

        #region Buscar Codigo Siguiente
        public INTERNO_ValorDevuelto_Modelo Buscar_CodigoSiguiente()
        {
            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                string str_CodigoSiguiente = Datos_Generales.Buscar_CodigoSiguiente(nameof(GTD_ConexionBDExterna),
                                                                                    nameof(GTD_ConexionBDExterna.codigo),
                                                                                    "",
                                                                                    -1,
                                                                                    true,
                                                                                    g_frm_P_ConexionBD_Externa.Exferia_TextBox_Codigo.Exferia_TextBox_MaxLength);

                if (!str_CodigoSiguiente.Equals("-1"))
                {
                    g_frm_P_ConexionBD_Externa.Exferia_TextBox_Codigo.Text = str_CodigoSiguiente;
                }
                else
                {
                    mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = false;
                    mdl_INTERNO_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_GENERAL_VALIDACIONES_CODIGOSIGUIENTE_LIMITEALCANZADO(g_frm_P_ConexionBD_Externa.Exferia_Label_Codigo.Text);
                }
            }
            catch (Control_Errores)
            {
                mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_INTERNO_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_BUSCARCODIGOSIGUIENTE();
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_ConexionBD_Externa_Controladora) + "/" + nameof(Buscar_CodigoSiguiente));
                mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_INTERNO_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_BUSCARCODIGOSIGUIENTE();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

        #region Cargar Datos
        public void RecargarDatos()
        {
            try
            {

                //Bloquear el formulario para que no se pueda hacer nada hasta que termine
                g_frm_P_ConexionBD_Externa.Enabled = false;

                //Mostrar la pantalla de espera
                g_frm_PE_Esperando = new PE_Esperando();

                // Si la tarea asincrona esta en marcha la paro
                if (g_obj_TareaAsincrona_CargarDatos != null)
                {
                    while (g_obj_TareaAsincrona_CargarDatos.IsBusy)
                        Application.DoEvents();
                }
                else
                {
                    g_obj_TareaAsincrona_CargarDatos = new BackgroundWorker();
                    g_obj_TareaAsincrona_CargarDatos.DoWork += new DoWorkEventHandler(TareaAsincrona_CargarDatos_DoWork);
                    g_obj_TareaAsincrona_CargarDatos.RunWorkerCompleted += new RunWorkerCompletedEventHandler(TareaAsincrona_CargarDatos_Completed);
                    g_obj_TareaAsincrona_CargarDatos.WorkerReportsProgress = false;
                }


                g_bol_Termino_CargaDatos_Inicial = false;

                //Vaciar
                VaciarDatos();

                //(Tarea Asincrona) Cargar Datos ##################################################################
                g_obj_TareaAsincrona_CargarDatos.RunWorkerAsync();
                //#################################################################################################

                g_frm_PE_Esperando.ShowDialog();
            }
            catch (Exception ex)
            {
                g_frm_P_ConexionBD_Externa.Enabled = true;

                g_bol_Termino_CargaDatos_Inicial = true;

                if (g_frm_PE_Esperando != null)
                {
                    g_frm_PE_Esperando.Close();
                    g_frm_PE_Esperando = null;
                }

                throw new Control_Errores("", ex, nameof(P_ConexionBD_Externa_Controladora) + "/" + nameof(RecargarDatos), true);
            }
        }
        private void TareaAsincrona_CargarDatos_DoWork(object sender, DoWorkEventArgs e)
        {
            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                if (CargarDatos(g_frm_P_ConexionBD_Externa.P_Base_id) == false)
                {
                    mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = false;
                    mdl_INTERNO_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA();
                }
            }
            catch (ThreadAbortException ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_ConexionBD_Externa_Controladora) + "/" + nameof(TareaAsincrona_CargarDatos_DoWork));

                mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_INTERNO_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA();
            }
            catch (Control_Errores)
            {
                mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_INTERNO_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA();
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_ConexionBD_Externa_Controladora) + "/" + nameof(TareaAsincrona_CargarDatos_DoWork));
                mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_INTERNO_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA();
            }
            finally
            {
                e.Result = mdl_INTERNO_ValorDevuelto_Modelo;
            }
        }
        private void TareaAsincrona_CargarDatos_Completed(object sender, RunWorkerCompletedEventArgs e)
        {

            if (g_frm_PE_Esperando != null)
            {
                g_frm_PE_Esperando.Close();
                g_frm_PE_Esperando = null;
            }

            //Desbloquear el Formulario
            g_frm_P_ConexionBD_Externa.Enabled = true;

            try
            {
                INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo_Resultado = (INTERNO_ValorDevuelto_Modelo)e.Result;

                //Mostrar si tuviera algun mensaje
                if (mdl_ValorDevuelto_Modelo_Resultado.TodoCorrecto == false)
                {
                    Mensajes.MostrarMensaje(mdl_ValorDevuelto_Modelo_Resultado.Mensaje);
                    g_frm_P_ConexionBD_Externa.Salir_P_Base();
                }
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_ConexionBD_Externa_Controladora) + "/" + nameof(TareaAsincrona_CargarDatos_Completed));
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());

                g_frm_P_ConexionBD_Externa.Salir_P_Base();
            }
            finally
            {
                g_bol_Termino_CargaDatos_Inicial = true;

                //Hacemos foco al primer control.
                g_frm_P_ConexionBD_Externa.Exferia_TextBox_Servidor.Exferia_TextBox_Foco();
            }
        }
        public bool CargarDatos(long _lng_id)
        {
            bool bol_ValorDevuelto = true;

            try
            {
                g_mdl_GTD_ConexionBDExterna = g_obj_GTD_ConexionBDExterna_Datos.Obtener(_lng_id);

                //Si no es Nulo Cargo lo Datos
                if (g_mdl_GTD_ConexionBDExterna != null)
                {
                    //Paginador ................................................................................
                    if (g_frm_P_ConexionBD_Externa.P_Base_PantallaOrigen != null &&
                        g_frm_P_ConexionBD_Externa.P_Base_PantallaOrigen.P_Base_Objetos_Filtrados != null &&
                        g_frm_P_ConexionBD_Externa.P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.Count > 0)
                    {
                        long lng_id_ParaPaginacion = g_mdl_GTD_ConexionBDExterna.id;
                        int int_PaginaDelObjeto = g_frm_P_ConexionBD_Externa.P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.IndexOf(g_frm_P_ConexionBD_Externa.P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.Where(n => n.ID.Equals(lng_id_ParaPaginacion)).FirstOrDefault());

                        g_frm_P_ConexionBD_Externa.g_obj_Funciones_Paginador.SetPaginaActual(int_PaginaDelObjeto);
                        // Asignando al paginador la pagina actual.
                        g_frm_P_ConexionBD_Externa.Exferia_Paginador_Tipo.PaginaActual = g_frm_P_ConexionBD_Externa.g_obj_Funciones_Paginador.GetPaginaActual();
                    }
                    //...........................................................................................


                    //codigo
                    g_frm_P_ConexionBD_Externa.Exferia_TextBox_Codigo.Text = g_mdl_GTD_ConexionBDExterna.codigo;

                    //descripcion
                    g_frm_P_ConexionBD_Externa.Exferia_TextBox_Descripcion.Text = g_mdl_GTD_ConexionBDExterna.descripcion;

                    //servidor
                    g_frm_P_ConexionBD_Externa.Exferia_TextBox_Servidor.Text = g_mdl_GTD_ConexionBDExterna.servidor;

                    //baseDatos
                    g_frm_P_ConexionBD_Externa.Exferia_TextBox_BaseDeDatos.Text = g_mdl_GTD_ConexionBDExterna.baseDatos;

                    //tipoBaseDatos
                    INTERNO_ComboBox_Modelo mdl_INTERNO_ComboBox_Modelo_TIPO = g_lst_INTERNO_ComboBox_Modelo_TIPOBASEDATOS.Where(m => m.Identificador.Equals(g_mdl_GTD_ConexionBDExterna.tipoBaseDatos)).FirstOrDefault();
                    if (mdl_INTERNO_ComboBox_Modelo_TIPO != null)
                    {
                        g_frm_P_ConexionBD_Externa.Exferia_ComboBox_Tipo.SelectedItem = mdl_INTERNO_ComboBox_Modelo_TIPO;
                    }
                    
                    //Con Clave
                    if (g_mdl_GTD_ConexionBDExterna.tieneUsuario)
                    {
                        g_frm_P_ConexionBD_Externa.Exferia_RadioButton_ConClave.Checked = true;
                        g_frm_P_ConexionBD_Externa.Exferia_RadioButton_SinClave.Checked = false;
                        g_frm_P_ConexionBD_Externa.Exferia_TextBox_Usuario.Text = g_mdl_GTD_ConexionBDExterna.usuario;
                        g_frm_P_ConexionBD_Externa.Exferia_TextBox_Clave.Text = g_obj_Encriptador.Desencriptar(g_mdl_GTD_ConexionBDExterna.clave);
                    }
                    //Sin Clave
                    else
                    {
                        g_frm_P_ConexionBD_Externa.Exferia_RadioButton_SinClave.Checked = true;
                        g_frm_P_ConexionBD_Externa.Exferia_RadioButton_ConClave.Checked = false;
                    }

                    g_frm_P_ConexionBD_Externa.P_Base_SeModificoDatosPantalla = false;
                }
                
            }
            catch (Control_Errores)
            {
                bol_ValorDevuelto = false;
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_ConexionBD_Externa_Controladora) + "/" + nameof(CargarDatos));
                bol_ValorDevuelto = false;
            }

            return bol_ValorDevuelto;
        }
        #endregion

        #region Grabar Datos
        public void GrabarDatos()
        {
            try
            {
                g_bol_GrabarDatos_TerminoCorrectamente = true;

                g_frm_P_ConexionBD_Externa.Enabled = false;
                g_frm_PE_Esperando = new PE_Esperando(Mensajes.G_STR_ESPERANDO_GRABANDODATOS());

                g_obj_TareaAsincrona_GrabarDatos = new BackgroundWorker();
                g_obj_TareaAsincrona_GrabarDatos.DoWork += new DoWorkEventHandler(TareaAsincrona_GrabarDatos_DoWork);
                g_obj_TareaAsincrona_GrabarDatos.RunWorkerCompleted += new RunWorkerCompletedEventHandler(TareaAsincrona_GrabarDatos_Completed);
                g_obj_TareaAsincrona_GrabarDatos.RunWorkerAsync();

                g_frm_PE_Esperando.ShowDialog();
            }
            catch (Exception ex)
            {
                g_bol_GrabarDatos_TerminoCorrectamente = false;
                if (g_frm_PE_Esperando != null)
                {
                    g_frm_PE_Esperando.Close();
                    g_frm_PE_Esperando = null;
                }
                g_frm_P_ConexionBD_Externa.Enabled = true;

                Control_Errores.Errores_Log("", ex, nameof(P_ConexionBD_Externa_Controladora) + "/" + nameof(GrabarDatos));
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_GRABARDATOSPANTALLA());
            }
        }
        private void TareaAsincrona_GrabarDatos_DoWork(object sender, DoWorkEventArgs e)
        {
            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                // Validar Primero
                INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo_VALIDACION = ValidarDatos();
                if (mdl_ValorDevuelto_Modelo_VALIDACION.TodoCorrecto)
                {
                    mdl_INTERNO_ValorDevuelto_Modelo = GrabarDatos_Final();
                }
                else
                {
                    mdl_INTERNO_ValorDevuelto_Modelo = mdl_ValorDevuelto_Modelo_VALIDACION;
                }
            }
            catch (ThreadAbortException ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_ConexionBD_Externa_Controladora) + "/" + nameof(TareaAsincrona_GrabarDatos_DoWork));

                mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_INTERNO_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_GRABARDATOSPANTALLA();
            }
            catch (Control_Errores)
            {
                mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_INTERNO_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_GRABARDATOSPANTALLA();
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_ConexionBD_Externa_Controladora) + "/" + nameof(TareaAsincrona_GrabarDatos_DoWork));

                mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_INTERNO_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_GRABARDATOSPANTALLA();
            }
            finally
            {
                e.Result = mdl_INTERNO_ValorDevuelto_Modelo;
            }
        }
        private void TareaAsincrona_GrabarDatos_Completed(object sender, RunWorkerCompletedEventArgs e)
        {
            if (g_frm_PE_Esperando != null)
            {
                g_frm_PE_Esperando.Close();
                g_frm_PE_Esperando = null;
            }
            g_frm_P_ConexionBD_Externa.Enabled = true;

            try
            {
                INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo_Resultado = (INTERNO_ValorDevuelto_Modelo)e.Result;

                //Mostrar si tuviera algun mensaje
                if (mdl_ValorDevuelto_Modelo_Resultado.TodoCorrecto == false)
                {
                    if (mdl_ValorDevuelto_Modelo_Resultado.Mensaje!=null && mdl_ValorDevuelto_Modelo_Resultado.Mensaje.Trim().Length > 0)
                    {
                        Mensajes.MostrarMensaje(mdl_ValorDevuelto_Modelo_Resultado.Mensaje);

                        //Poner el Foco en el objeto que tuvoel problema en validar
                        if (mdl_ValorDevuelto_Modelo_Resultado.Objeto != null)
                        {
                            Funciones.Poner_Foco_Objeto(g_frm_P_ConexionBD_Externa, mdl_ValorDevuelto_Modelo_Resultado.Objeto);
                        }
                    }

                    g_bol_GrabarDatos_TerminoCorrectamente = false;
                }
                else
                {
                    // Recargar el Listado
                    if (g_frm_P_ConexionBD_Externa.P_Base_PantallaOrigen != null)
                    {
                        g_frm_P_ConexionBD_Externa.P_Base_PantallaOrigen.P_Base_ActualizarRegistro(mdl_ValorDevuelto_Modelo_Resultado.Id, mdl_ValorDevuelto_Modelo_Resultado.TipoAccion);
                    }
                    else if (g_frm_P_ConexionBD_Externa.P_Base_F3Origen != null)
                    {
                        g_frm_P_ConexionBD_Externa.P_Base_F3Origen.Exferia_F3_ActualizarRegistro(mdl_ValorDevuelto_Modelo_Resultado.Id, mdl_ValorDevuelto_Modelo_Resultado.TipoAccion);
                    }

                    //Cerrar pantalla
                    g_frm_P_ConexionBD_Externa.P_Base_SeModificoDatosPantalla = false;
                    g_frm_P_ConexionBD_Externa.Salir_P_Base();
                }
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_ConexionBD_Externa_Controladora) + "/" + nameof(TareaAsincrona_GrabarDatos_Completed));
            }
        }
        public INTERNO_ValorDevuelto_Modelo ValidarDatos()
        {
            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                //Si el codigo esta vacio y se intenta buscar el ultimo numerico y llego al limite de base de datos
                if (g_frm_P_ConexionBD_Externa.Exferia_TextBox_Codigo.Text.Trim().Length == 0)
                {
                    INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo_AUX = Buscar_CodigoSiguiente();

                    if (mdl_INTERNO_ValorDevuelto_Modelo_AUX.TodoCorrecto == false)
                    {
                        mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = false;
                        mdl_INTERNO_ValorDevuelto_Modelo.Mensaje = mdl_INTERNO_ValorDevuelto_Modelo_AUX.Mensaje;
                        mdl_INTERNO_ValorDevuelto_Modelo.Objeto = g_frm_P_ConexionBD_Externa.Exferia_TextBox_Codigo;
                    }
                }

                // El codigo no puede estar Repetido
                if (mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto)
                {
                    string str_Codigo = g_frm_P_ConexionBD_Externa.Exferia_TextBox_Codigo.Text.Trim();
                    if (g_bol_CampoCodigo_Numerico)
                    {
                        int int_Codigo = int.Parse(str_Codigo);
                        str_Codigo = int_Codigo.ToString();
                    }

                    if (Datos_Generales.Buscar_CodigoRepetido(nameof(GTD_ConexionBDExterna), nameof(GTD_ConexionBDExterna.codigo), str_Codigo, nameof(GTD_ConexionBDExterna.id), (g_mdl_GTD_ConexionBDExterna != null ? g_mdl_GTD_ConexionBDExterna.id : -1), "", -1, true))
                    {
                        mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = false;
                        mdl_INTERNO_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_GENERAL_VALIDACIONES_REPETIDO(g_frm_P_ConexionBD_Externa.Exferia_Label_Codigo.Text);
                        mdl_INTERNO_ValorDevuelto_Modelo.Objeto = g_frm_P_ConexionBD_Externa.Exferia_TextBox_Codigo;
                    }
                }

                // La descripcion no puede estar vacía
                if (mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto && g_frm_P_ConexionBD_Externa.Exferia_TextBox_Descripcion.Text.Trim().Length == 0)
                {
                    mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = false;
                    mdl_INTERNO_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_GENERAL_VALIDACIONES_VACIO(g_frm_P_ConexionBD_Externa.Exferia_Label_Descripcion.Text);
                    mdl_INTERNO_ValorDevuelto_Modelo.Objeto = g_frm_P_ConexionBD_Externa.Exferia_TextBox_Descripcion;
                }


                // El Servidor no puede estar vacía
                if (mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto && g_frm_P_ConexionBD_Externa.Exferia_TextBox_Servidor.Text.Trim().Length == 0)
                {
                    mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = false;
                    mdl_INTERNO_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_GENERAL_VALIDACIONES_VACIO(g_frm_P_ConexionBD_Externa.Exferia_Label_Servidor.Text);
                    mdl_INTERNO_ValorDevuelto_Modelo.Objeto = g_frm_P_ConexionBD_Externa.Exferia_TextBox_Servidor;
                }

                // la base de datos no puede estar vacía
                if (mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto && g_frm_P_ConexionBD_Externa.Exferia_TextBox_BaseDeDatos.Text.Trim().Length == 0)
                {
                    mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = false;
                    mdl_INTERNO_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_GENERAL_VALIDACIONES_VACIO(g_frm_P_ConexionBD_Externa.Exferia_Label_BaseDeDatos.Text);
                    mdl_INTERNO_ValorDevuelto_Modelo.Objeto = g_frm_P_ConexionBD_Externa.Exferia_TextBox_BaseDeDatos;
                }

                // El Tipo no puede estar vacío
                if (mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto && g_frm_P_ConexionBD_Externa.Exferia_ComboBox_Tipo.SelectedItem == null)
                {
                    mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = false;
                    mdl_INTERNO_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_GENERAL_VALIDACIONES_NOSELECCIONADO(g_frm_P_ConexionBD_Externa.Exferia_Label_Tipo.Text);
                    mdl_INTERNO_ValorDevuelto_Modelo.Objeto = g_frm_P_ConexionBD_Externa.Exferia_ComboBox_Tipo;
                }

                //Si tiene Clave
                if (mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto && g_frm_P_ConexionBD_Externa.Exferia_RadioButton_ConClave.Checked)
                {
                    // El usuario no puede estar vacía
                    if (mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto && g_frm_P_ConexionBD_Externa.Exferia_TextBox_Usuario.Text.Trim().Length == 0)
                    {
                        mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = false;
                        mdl_INTERNO_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_GENERAL_VALIDACIONES_VACIO(g_frm_P_ConexionBD_Externa.Exferia_Label_Usuario.Text);
                        mdl_INTERNO_ValorDevuelto_Modelo.Objeto = g_frm_P_ConexionBD_Externa.Exferia_TextBox_Usuario;
                    }

                    // La clave no puede estar vacía
                    if (mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto && g_frm_P_ConexionBD_Externa.Exferia_TextBox_Clave.Text.Trim().Length == 0)
                    {
                        mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = false;
                        mdl_INTERNO_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_GENERAL_VALIDACIONES_VACIO(g_frm_P_ConexionBD_Externa.Exferia_Label_Clave.Text);
                        mdl_INTERNO_ValorDevuelto_Modelo.Objeto = g_frm_P_ConexionBD_Externa.Exferia_TextBox_Clave;
                    }
                }


                //Probar la Conexion
                if (mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto)
                {
                    if (!g_obj_ConexionExterna_Datos.Probar_Conexion(   g_frm_P_ConexionBD_Externa.Exferia_TextBox_Servidor.Text,
                                                                        g_frm_P_ConexionBD_Externa.Exferia_TextBox_BaseDeDatos.Text,
                                                                        g_frm_P_ConexionBD_Externa.Exferia_RadioButton_ConClave.Checked,
                                                                        g_frm_P_ConexionBD_Externa.Exferia_TextBox_Usuario.Text,
                                                                        g_frm_P_ConexionBD_Externa.Exferia_TextBox_Clave.Text))
                    {
                        mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = false;
                        mdl_INTERNO_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_CONEXION_VALIDACION_MAL;
                    }
                }

            }
            catch (Control_Errores)
            {
                mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_INTERNO_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_VALIDARDATOSPANTALLA();
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_ConexionBD_Externa_Controladora) + "/" + nameof(ValidarDatos));

                mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_INTERNO_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_VALIDARDATOSPANTALLA();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        private INTERNO_ValorDevuelto_Modelo GrabarDatos_Final()
        {
            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();

            try
            {

                GTD_ConexionBDExterna mdl_GTD_ConexionBDExterna = new GTD_ConexionBDExterna();

                //id
                mdl_GTD_ConexionBDExterna.id = g_mdl_GTD_ConexionBDExterna != null ? g_mdl_GTD_ConexionBDExterna.id : -1;

                //codigo
                mdl_GTD_ConexionBDExterna.codigo = g_frm_P_ConexionBD_Externa.Exferia_TextBox_Codigo.Text.Trim();

                //descripcion
                mdl_GTD_ConexionBDExterna.descripcion = g_frm_P_ConexionBD_Externa.Exferia_TextBox_Descripcion.Text.Trim();

                //servidor
                mdl_GTD_ConexionBDExterna.servidor = g_frm_P_ConexionBD_Externa.Exferia_TextBox_Servidor.Text.Trim();

                //baseDatos
                mdl_GTD_ConexionBDExterna.baseDatos = g_frm_P_ConexionBD_Externa.Exferia_TextBox_BaseDeDatos.Text.Trim();

                //tipoBaseDatos
                mdl_GTD_ConexionBDExterna.tipoBaseDatos = ((INTERNO_ComboBox_Modelo)g_frm_P_ConexionBD_Externa.Exferia_ComboBox_Tipo.SelectedItem).Identificador;

                //Con Clave
                if (g_frm_P_ConexionBD_Externa.Exferia_RadioButton_ConClave.Checked)
                {
                    //tieneUsuario
                    mdl_GTD_ConexionBDExterna.tieneUsuario = true;

                    //usuario
                    mdl_GTD_ConexionBDExterna.usuario = g_frm_P_ConexionBD_Externa.Exferia_TextBox_Usuario.Text.Trim();

                    //clave
                    mdl_GTD_ConexionBDExterna.clave = g_obj_Encriptador.Encriptar(g_frm_P_ConexionBD_Externa.Exferia_TextBox_Clave.Text.Trim());
                }
                //Sin Clave
                else
                {
                    //tieneUsuario
                    mdl_GTD_ConexionBDExterna.tieneUsuario = false;

                    //usuario
                    mdl_GTD_ConexionBDExterna.usuario = "";

                    //clave
                    mdl_GTD_ConexionBDExterna.clave = "";
                }
                    
                // Se graba el modelo ya relleno.
                mdl_INTERNO_ValorDevuelto_Modelo = g_obj_GTD_ConexionBDExterna_Datos.Grabar(mdl_GTD_ConexionBDExterna);
                
            }
            catch (Control_Errores)
            {
                mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_INTERNO_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_GRABARDATOSPANTALLA();
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_ConexionBD_Externa_Controladora) + "/" + nameof(GrabarDatos_Final));
                mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_INTERNO_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_GRABARDATOSPANTALLA();
            }
            
            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion


        #region Borrar Datos
        public void BorrarDatos()
        {
            try
            {
                //PReguntar si esta Seguro de Borrar
                if (Mensajes.MostrarMensaje_Pregunta(Mensajes.G_STR_MENSAJES_GENERAL_PREGUNTA_BORRAR()))
                {
                    g_frm_P_ConexionBD_Externa.Enabled = false;
                    g_frm_PE_Esperando = new PE_Esperando(Mensajes.G_STR_ESPERANDO_BORRANDODATOS());

                    g_obj_TareaAsincrona_BorrarDatos = new BackgroundWorker();
                    g_obj_TareaAsincrona_BorrarDatos.DoWork += new DoWorkEventHandler(TareaAsincrona_BorrarDatos_DoWork);
                    g_obj_TareaAsincrona_BorrarDatos.RunWorkerCompleted += new RunWorkerCompletedEventHandler(TareaAsincrona_BorrarDatos_Completed);
                    g_obj_TareaAsincrona_BorrarDatos.RunWorkerAsync();

                    g_frm_PE_Esperando.ShowDialog();
                }
            }
            catch (Exception ex)
            {
                if (g_frm_PE_Esperando != null)
                {
                    g_frm_PE_Esperando.Close();
                    g_frm_PE_Esperando = null;
                }

                g_frm_P_ConexionBD_Externa.Enabled = true;

                Control_Errores.Errores_Log("", ex, nameof(P_ConexionBD_Externa_Controladora) + "/" + nameof(BorrarDatos));
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_BORRARDATOSPANTALLA());
            }
        }

        private void TareaAsincrona_BorrarDatos_DoWork(object sender, DoWorkEventArgs e)
        {
            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                //Borrar
                mdl_ValorDevuelto_Modelo = BorrarDatos_Final();
            }
            catch (ThreadAbortException ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_ConexionBD_Externa_Controladora) + "/" + nameof(TareaAsincrona_BorrarDatos_DoWork));

                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_BORRARDATOSPANTALLA();
            }
            catch (Control_Errores)
            {
                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_BORRARDATOSPANTALLA();
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_ConexionBD_Externa_Controladora) + "/" + nameof(TareaAsincrona_BorrarDatos_DoWork));

                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_BORRARDATOSPANTALLA();
            }
            finally
            {
                e.Result = mdl_ValorDevuelto_Modelo;
            }
        }
        private void TareaAsincrona_BorrarDatos_Completed(object sender, RunWorkerCompletedEventArgs e)
        {
            if (g_frm_PE_Esperando != null)
            {
                g_frm_PE_Esperando.Close();
                g_frm_PE_Esperando = null;
            }
            g_frm_P_ConexionBD_Externa.Enabled = true;

            try
            {


                INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo_Resultado = (INTERNO_ValorDevuelto_Modelo)e.Result;

                //Mostrar si tuviera algun mensaje
                if (mdl_ValorDevuelto_Modelo_Resultado.TodoCorrecto == false)
                {
                    if (mdl_ValorDevuelto_Modelo_Resultado.Mensaje.Trim().Length > 0)
                    {
                        Mensajes.MostrarMensaje(mdl_ValorDevuelto_Modelo_Resultado.Mensaje);
                    }
                }
                else
                {
                    // Devolver al Listado el Row Borrar
                    if (g_frm_P_ConexionBD_Externa.P_Base_PantallaOrigen != null)
                    {
                        g_frm_P_ConexionBD_Externa.P_Base_PantallaOrigen.P_Base_ActualizarRegistro(mdl_ValorDevuelto_Modelo_Resultado.Id, mdl_ValorDevuelto_Modelo_Resultado.TipoAccion);
                    }
                    else if (g_frm_P_ConexionBD_Externa.P_Base_F3Origen != null)
                    {
                        g_frm_P_ConexionBD_Externa.P_Base_F3Origen.Exferia_F3_ActualizarRegistro(mdl_ValorDevuelto_Modelo_Resultado.Id, mdl_ValorDevuelto_Modelo_Resultado.TipoAccion);
                    }

                    //Salir de la pantalla
                    g_frm_P_ConexionBD_Externa.P_Base_SeModificoDatosPantalla = false;
                    g_frm_P_ConexionBD_Externa.Salir_P_Base();
                    
                }
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_ConexionBD_Externa_Controladora) + "/" + nameof(TareaAsincrona_BorrarDatos_Completed));
            }
        }

        private INTERNO_ValorDevuelto_Modelo BorrarDatos_Final()
        {
            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            try
            {
                mdl_ValorDevuelto_Modelo = g_obj_GTD_ConexionBDExterna_Datos.Borrar(g_mdl_GTD_ConexionBDExterna != null ? g_mdl_GTD_ConexionBDExterna.id : -1);
            }
            catch (Control_Errores)
            {
                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_BORRARDATOSPANTALLA();
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_ConexionBD_Externa_Controladora) + "/" + nameof(BorrarDatos_Final));
                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_BORRARDATOSPANTALLA();
            }
            return mdl_ValorDevuelto_Modelo;
        }
        #endregion
    }
}
